import { Injectable } from '@angular/core';
import { Observable, of } from 'rxjs';
import { HttpClient } from '@angular/common/http';

import { Hero } from './hero';
import { MessageService } from './message.service';
import { HEROES } from './mock-heroes'

@Injectable({
  providedIn: 'root'
})
export class HeroService {
  constructor(private messageService: MessageService, private http: HttpClient) { }

  getHeroes(): Observable<Hero[]> {
    this.messageService.add('HeroService: fetched heroes');
    // return of(HEROES)
    return this.http.get<Hero[]>(`http://172.16.3.185:5000/heroes`)
  }

  getHero(id: number): Observable<any> {
    this.messageService.add(`HeroService: fetch hero id=${id}`);
    // return of(HEROES.find(hero => hero.id === id))
    return this.http.get<Hero>(`http://172.16.3.185:5000/hero?id=${id}`)
  }

  updateHero(hero: Hero): Observable<any> {
    this.messageService.add(`HeroService: save change: id=${hero.id}, name=${hero.name}`);
    return of(true);
  }
}
